<template>
    <div class="index_container" ref="main">
        <section class="anchor_tags" id="intro">
            <div id="image-gsap"></div>

            <div class="main-intro-title">
                <h1>
                    <span class="box"></span>
                    <span class="hi">Hi, I'm</span>
                    <br class="d-sm-none" />
                    <span class="text"></span>
                    <span class="cursor">_</span>
                </h1>
            </div>
        </section>

        <about />

        <demos />

        <div class="wawe-bg-top">
            <svg>
                <clipPath id="wave-top" clipPathUnits="objectBoundingBox">
                    <path class="st0" d="M 1 0 c 0 0 -0.166 0.254 -0.338 0.315 S 0.3 0 0.001 0.308 V 1 h 1 L 1 0 z" />
                </clipPath>
            </svg>
        </div>

        <devops />

        <div class="wawe-bg-bottom">
            <svg>
                <clipPath id="wave-bottom" clipPathUnits="objectBoundingBox">
                    <path class="st0" d="M 1 0 c 0 0 -0.146 0.075 -0.421 0.048 S 0.3 0 0 0.038 V 1 h 1 L 1 0 Z" />
                </clipPath>
            </svg>
            <div class="container-fluid">
                <div class="row pt-5">
                    <div class="col-md-3 col-12 text-center text-light my-3">
                        <img src="/images/design.svg" alt="" width="150" height="auto" />
                        <p class="py-3 text-warning font-24">Website Design</p>
                        <p>Highlight your brand’s identity through and advanced user experience.</p>
                    </div>
                    <div class="col-md-3 col-12 text-center text-light my-3">
                        <img src="/images/develop.svg" alt="" width="150" height="auto" />
                        <p class="py-3 text-warning font-24">Website Development</p>
                        <p>Custom solutions that support your business growth goals.</p>
                    </div>
                    <div class="col-md-3 col-12 text-center text-light my-3">
                        <img src="/images/hosting.svg" alt="" width="150" height="auto" />
                        <p class="py-3 text-warning font-24">Hosting & Maintenance</p>
                        <p>Keep your website secure, stable, and virus-free.</p>
                    </div>
                    <div class="col-md-3 col-12 text-center text-light my-3">
                        <img src="/images/seo.svg" alt="" width="150" height="auto" />
                        <p class="py-3 text-warning font-24">Search Engine Optimization</p>
                        <p>Get Google’s attention with the right content and a solid framework.</p>
                    </div>
                </div>
            </div>
            <div class="d-flex justify-content-center align-items-center py-4 mt-5">
                <button class="btn btn-outline-warning px-4 py-2 mr-3" @click="downloadPDF()">Resume</button>
                <a href="mailto:bozidar.atanasovski@hotmail.com?subject=Message from my site&body=Hi :)" class="btn btn-outline-warning px-4 py-2">Contact</a>
            </div>
        </div>
    </div>
</template>
<script>
    import { gsap } from "gsap/dist/gsap";
    import { ScrollTrigger } from "gsap/dist/ScrollTrigger";
    import { TextPlugin } from "gsap/dist/TextPlugin";
    import { CSSPlugin } from "gsap/CSSPlugin";
    import { MotionPathPlugin } from "gsap/dist/MotionPathPlugin";

    gsap.registerPlugin(ScrollTrigger);
    gsap.registerPlugin(TextPlugin);
    gsap.registerPlugin(MotionPathPlugin);
    gsap.registerPlugin(CSSPlugin);

    import About from "./pages/About";
    import Portfolio from "./pages/Portfolio";
    import Demos from "./pages/Demos";
    import Contact from "./pages/Contact";
    import Devops from "./pages/Devops";

    export default {
        components: { About, Portfolio, Demos, Contact, Devops },

        data() {
            return {
                boxWidth: 200,
            };
        },

        computed: {
            totalWidth() {
                return this.boxWidth * 10;
            },
        },

        mounted() {
            // Init particle photo
            imageParticles.init(document.getElementById("image-gsap"));

            // Introduction words animation
            const words = ["Bozhidar", "Web devoloper"];
            // Create typing animation
            const words_animation = gsap.timeline({ repeat: -1 }).pause();
            // Words Animation
            gsap.timeline()
                .to(".box", 1, { width: "25vw", delay: 0.5, ease: "power4.inOut" })
                .from(".hi", 1, { y: "7vw", ease: "power3.out", onComplete: () => words_animation.play() }, "-=1")
                .to(".box", 1, { height: "7vw", ease: "elastic.out" })
                .to(".box", 2, {
                    autoAlpha: 0.5,
                    yoyo: true,
                    repeat: -1,
                    ease: "rough({template: none.out, strength: 1, points: 20, taper: 'none', randomize: true, clamp: false})",
                });
            // Words Animation
            words.forEach(item => {
                let word = gsap.timeline({ repeat: 1, yoyo: true, repeatDelay: 1.5 });
                word.to(".text", { duration: 2, text: item });
                words_animation.add(word);
            });

            // Show who i am
            let introScroll = this.createTimeline("#intro", "center center", "bottom top");
            introScroll.to(".main-intro-title", 1, {
                opacity: 0,
                onStart: () => {
                    imageParticles.hide();
                },
            });

            let aboutScroll = this.createTimeline("#about", "top bottom", "bottom bottom");

            aboutScroll
                .from("#about h1.tech-font", { xPercent: 0, duration: 3 }, "-1")
                .to("#about .text__first-bg", { scaleX: 1, duration: 3 }, "<")
                .to("#about .text__word", { opacity: 1, duration: 3 })
                .from("#about .about-content.mt-5", { opacity: 0, yPercent: 50, duration: 3 })
                .from("#about .about-content.mt-5 .border-line-bottom", { width: 0, duration: 3 })
                .to("#about .text__first-bg", {
                    scaleX: 0,
                    duration: 3,
                    onReverseComplete: () => {
                        imageParticles.show(0);
                    },
                })
                .from("#about .about-content.mt-0", 3, { opacity: 0, yPercent: 75 });

            window.innerWidth > 600
                ? aboutScroll.from("#laptop-gsap", 3, { xPercent: 100, opacity: 0 })
                : aboutScroll.fromTo("#laptop-gsap", 3, { xPercent: 150, opacity: 0 }, { xPercent: 20, opacity: 1 });

            let demoScroll = this.createTimeline("#demos", "top bottom", "bottom bottom");

            demoScroll
                .from("#demos .first-content", { opacity: 0, xPercent: 5, duration: 3 })
                .from("#demos .second-content", { opacity: 0, xPercent: -5, duration: 3 })
                .from("#demos .third-content", { opacity: 0, xPercent: 5, duration: 3 })
                .from("#demos .four-content", { opacity: 0, xPercent: -5, duration: 3 })
                .from("#demos .five-content", { opacity: 0, xPercent: 5, duration: 3 })
                .from("#demos .six-content", { opacity: 0, xPercent: -5, duration: 3 })
                .from("#demos .seven-content", { opacity: 0, xPercent: 5, duration: 3 })
                .from("#demos .eight-content", { opacity: 0, xPercent: -5, duration: 3 })
                .from("#demos .nine-content", { opacity: 0, xPercent: 5, duration: 3 })
                .from("#demos .ten-content", { opacity: 0, xPercent: -5, duration: 3 });

            let devScroll = this.createTimeline("#devops", "top bottom", "bottom bottom");
            devScroll
                .from("#devops h1.tech-font", 1, { xPercent: 0 })
                .to("#devops .text__first-bg", 2, { scaleX: 1 }, "<")
                .to("#devops .text__word", 1, { opacity: 1 })
                .to("#devops .text__first-bg", 2, { scaleX: 0 })
                .from(".fas.fa-globe-europe", 2, { y: -20, opacity: 0 })
                .from(".fas.fa-hammer", 2, { y: -20, opacity: 0 })
                .from(".fas.fa-pencil-ruler", 2, { y: -20, opacity: 0 })
                .from(".fas.fa-cogs", 2, { y: -20, opacity: 0 })
                .from(".fas.fa-layer-group", 2, { y: -20, opacity: 0 });

            // Infinite Stack Words Loop
            let stack = gsap
                .timeline()
                .add(this.marqueeFromLeft(document.querySelectorAll(".skills-block-front p"), 30))
                .add(this.marqueeFromRight(document.querySelectorAll(".skills-block-back p"), 20), 1);

            if (window.innerWidth > 600) {
                // Project Tiles Wawe
                var loop = gsap
                    .timeline({
                        paused: true,
                        onComplete: function() {
                            this.restart();
                        },
                    })
                    .to(".image.wave", 2, { ease: "sine.inOut", stagger: { each: 1 / 8 }, scale: 0.99, x: -8, y: 16 })
                    .to(".image.wave", 2, { ease: "sine.inOut", stagger: { each: 1 / 8 }, scale: 1, x: 0, y: 0 });
                loop.restart();
            }
        },

        methods: {
            createTimeline(trigger, start, end) {
                return gsap.timeline({
                    scrollTrigger: {
                        trigger: trigger,
                        start: start,
                        end: end,
                        scrub: 1,
                        toggleActions: "play pause reverse reset",
                    },
                });
            },

            marqueeFromLeft(box, time) {
                gsap.set(box, {
                    x: i => {
                        return i * this.boxWidth;
                    },
                });
                var action = gsap.timeline().to(box, {
                    duration: time,
                    ease: "none",
                    x: "+=1750",
                    modifiers: {
                        x: x => {
                            x = parseInt(x);
                            var newX = x % this.totalWidth;
                            return newX + "px";
                        },
                    },
                    repeat: -1,
                });
                return action;
            },

            marqueeFromRight(box, time) {
                gsap.set(box, {
                    x: i => {
                        return i * this.boxWidth;
                    },
                });
                var action = gsap.timeline().to(box, {
                    duration: time,
                    ease: "none",
                    x: "-=1750",
                    modifiers: {
                        x: x => {
                            x = parseInt(x);
                            var newX = x < 0 ? (x % this.totalWidth) + this.totalWidth : x;
                            return newX + "px";
                        },
                    },
                    repeat: -1,
                });
                return action;
            },
        },
    };
</script>

<style scoped>
    .index_container {
        position: relative;
        overflow: hidden;
    }

    #intro {
        width: 100%;
        height: 100vh;
        position: relative;
    }

    #image-gsap {
        position: absolute;
        height: 100%;
        width: 100%;
        max-width: 1000px;
        bottom: 0px;
    }

    .main-intro-title {
        position: absolute;
        left: 50%;
        top: 40%;
        width: 100%;
    }

    .main-intro-title h1 {
        position: relative;
        overflow: hidden;
        color: white;
        font-size: 60px;
        margin-top: 10px;
    }

    .box {
        position: absolute;
        bottom: 0;
        display: inline-block;
        height: 1vw;
        z-index: -1;
    }

    .hi {
        display: inline-block;
        padding: 5px;
        background-color: #ffc107;
        color: #131417;
    }

    .wawe-bg-top {
        background-color: #1e1f26;
        clip-path: url(#wave-top);
        width: 100%;
        height: 100%;
        min-height: 500px;
        margin-top: -500px;
    }

    .wawe-bg-bottom {
        background-color: #131417;
        clip-path: url(#wave-top);
        width: 100%;
        height: 100%;
        margin-top: -200px;
    }

    .wawe-bg-bottom img {
        max-width: 150px;
        width: 100%;
        display: block;
        margin: 0 auto;
    }
</style>
